﻿window.external.notify('log;NativeCom ' + document.location+'. ua='+navigator.userAgent);

if (typeof window.ComNative == 'undefined' &&
	typeof (window.external) !== 'undefined' &&
	typeof (window.external.notify) !== 'undefined')
{
    ComNative = {};
    ComNative.sendMessage = function (nativeMethodAndArgs)
	{
		window.external.notify(nativeMethodAndArgs);
	};
}

function log(message)
{
    ComNative.sendMessage('log;' + message);
}

if (typeof window.console == 'undefined')
{
    window.console = {};
    console.log = function (msg)
    {
        log(msg);
    }
}

function resizeWindow(width)
{
	$(window).resize();
}

var conduit_events = {};

function event_bind(eventName, func)
{
//log('bind eventName = '+eventName+'. func='+func);
    if (typeof(func) !== 'function')
    {
        return;
    }

    if (!conduit_events[eventName])
    {
        conduit_events[eventName] = [];
    }
//log('bind conduit_events[eventName] = '+conduit_events[eventName]+'. add func '+func);
    conduit_events[eventName].push(func);
}

function event_unbind(eventName, func)
{
    if (conduit_events[eventName] === 'undefined')
    {
        return;
    }

    var index = conduit_events[eventName].indexOf(func);
    if (index >= 0)
    {
        conduit_events[eventName][index] = null;
    }
}

function conduit_fireEvent(eventName, params)
{
	try
	{
        if (typeof(AppManager) !== 'undefined')
        {
            //log('conduit_fireEvent: eventName='+eventName+'. pageId = '+params.pageId);
            AppManager.appView.trigger(eventName, params);
        }
	}
	catch(ex)
	{
	    //log('fire event exception: ' + ex.message);
    }
}

function conduit_fireEventForPage(eventName, pageId, params)
{
    var eparams = {pageId: pageId};
    if (params)
    {
        eparams.params = params;
    }
    conduit_fireEvent(eventName, eparams);
}

function deviceReady()
{
    try
    {
    AppInit.init();
    }
    catch(e)
    {
        console.log('deviceReady exception: '+e.message);
    }
}

// ---------------------------------------------------------------------
// Share help functions
// ---------------------------------------------------------------------

function socialShare(service, socialInfo)
{
    try
    {
        var shareOptions = JSON.parse(socialInfo);
        //log('socialShare call api: service='+socialInfo);
        conduitApi.social.share(null, null, service, shareOptions);
        //log('socialShare after call api');
    }
    catch(ex)
    {
        log('socialShare exception: '+ex.message);
    }
}

function share_post(service, inputMessage)
{
    function fbPostSuccess()
    {
        ComNative.sendMessage('Social;FBPostSuccess;');
    }
    function fbPostFail()
    {
        ComNative.sendMessage('Social;FBPostFail;');
    }

    function tweetSuccess()
    {
        ComNative.sendMessage('Social;TweetSuccess;');
    }
    function tweetFail()
    {
        ComNative.sendMessage('Social;TweetFail;');
    }

    service = parseInt(service);
    //log('share: service='+service+'. inputMessage='+inputMessage);

    switch (service)
    {
        case 0: // Facebook
        //log('\n\nFB Posting....\n');
            conduitApi.innerApi.share.postOnFacebook(fbPostSuccess, fbPostFail, inputMessage);
            break;
        case 1: // Twitter
        //log('\n\ntweeting....\n');
            conduitApi.innerApi.share.tweet(tweetSuccess, tweetFail, inputMessage);
            break;
    }
}

function share_changeUser()
{
}

// ---------------------------------------------------------------------
// Controllers help functions
// ---------------------------------------------------------------------
function controllerShowTab(controller, params)
{
    var tabIndex = parseInt(params);
    //log('native_tab_click : index='+tabIndex);
    if (tabIndex === controller.__tabIndex)
    {
        //log('native_tab_click call native');
        ComNative.sendMessage('PageCommand;' + window.PAGE_ID + ';showTabData;' + tabIndex);
    }
    controller.__showTab(tabIndex);
}

function nativeGetFeedsFailed()
{
    // Hide indicator
    conduitApi.UI.dismissActivityIndicator();
    ComNative.sendMessage('PageCommand;' + window.PAGE_ID + ';renderFeeds;Failure');
}

// ---------------------------------------------------------------------

// Override HTML constants for minified version
PLATFORM=platformEnum.nativeApp;
DEVICE=deviceTypeEnum.winPhone;

